import java.lang.*;
import java.sql.*;
import java.lang.reflect.Field;
import java.util.Date;
import java.util.Vector;

public class Yet 
{
    String oldPKs=new String();
    
    /* Saves current values of the object's PKde as a String
       It is used to generate the WHERE clause of the Update method
    */
    public void saveOldPks() throws Exception {
        oldPKs=getListOfPrimaryKeysAndValues();
        System.out.println(oldPKs);
    }
    
    Yet() {
        Vector fieldNames=this.getListOfFieldsWithVector(this.getClass());
        for (int i=0; i<fieldNames.size(); i++) {
            try {
                Field f=this.getClass().getDeclaredField((String) fieldNames.elementAt(i));                
                f.set(this, Vacio(f));
            }
            catch (Exception e) {}
        }
    }
    
    private Object Vacio(Field f) {
        if (f.getType().toString().compareTo("class java.lang.Long")==0)
            return new Long(0); else
        if (f.getType().toString().compareTo("class java.lang.Integer")==0)
            return new Integer(0); else            
        if (f.getType().toString().compareTo("class java.lang.Double")==0)
            return new Double(0.0); else
        if (f.getType().toString().compareTo("class java.lang.Boolean")==0)
            return new Boolean(false); else
        if (f.getType().toString().compareTo("class java.lang.String")==0)
            return new String(); else
        if (f.getType().toString().compareTo("class java.util.Date")==0)
            return new Date(); else
        if (f.getType().toString().compareTo("class java.util.Vector")==0)
            return new Vector();
        return new Object();
    }
    
    private Object valueOf(Field f, ResultSet r, int i) throws Exception {
        if (f.getType().toString().compareTo("class java.lang.Long")==0)
            return new Long(r.getLong(i)); else
        if (f.getType().toString().compareTo("class java.lang.Integer")==0)
            return new Integer(r.getInt(i)); else            
        if (f.getType().toString().compareTo("class java.lang.Double")==0)
            return new Double(r.getDouble(i)); else
        if (f.getType().toString().compareTo("class java.lang.Boolean")==0)
            return new Boolean(r.getBoolean(i)); else
        if (f.getType().toString().compareTo("class java.lang.String")==0)
            return new String(r.getString(i)); else
        if (f.getType().toString().compareTo("class java.util.Date")==0)
            return r.getDate(i); else
        if (f.getType().toString().compareTo("class java.util.Vector")==0) 
            return getVector(f);
        return new Object();
    }        
    
    // Carga en un atributo de clase Vector el valor de un vector
    // El nombre del atributo debe tener este formato:
    // m<Tabla>_<CampoDeBusqueda>_<CampoAMostrar>
    // Ej.: mSeccionOperario_Seccion_Nombre
    private Vector getVector(Field f) throws Exception {
        Vector result=new Vector();
        int posSub1=-1, posSub2=-1;
        for (int i=0; (i<f.getName().length()) && (posSub1==-1); i++)
            if (f.getName().charAt(i)=='_') posSub1=i;
        for (int i=posSub1+1; (i<f.getName().length()) && (posSub2==-1); i++)
            if (f.getName().charAt(i)=='_') posSub2=i;
        String NombreCampoBusqueda=f.getName().substring(posSub1+1, posSub2);
        String NombreCampoMuestra=f.getName().substring(posSub2+1);
        Field campoBusquedaPropio=
            this.getClass().getDeclaredField("mPK" + NombreCampoBusqueda);
        String claseBusqueda=campoBusquedaPropio.getType().toString();
        String valorBusqueda=campoBusquedaPropio.get(this).toString();
        if ((posSub1!=-1) && (posSub2!=-1)) {    
            String tabla=f.getName().substring(1, posSub1);
            String SQL="Select [" + NombreCampoMuestra + "] from [" + 
                tabla + "] where " + NombreCampoBusqueda + "=" + 
                marks(valorBusqueda, claseBusqueda);                    
            ResultSet r=Broker.bd.createStatement().executeQuery(SQL);
            while (r.next()) result.addElement(r.getObject(1));
        }
        return result;
    }
    
    Yet(String PKValues[]) throws Exception {
        this();
        String SQL="Select * from " + this.getClass().getName() + " where " +
            getListOfPKsAndValues(PKValues);
            System.out.println(SQL);
        ResultSet r=Broker.bd.createStatement().executeQuery(SQL);
        if (r.next()) {
            //Vector fieldNames=getListOfFieldsWithVector(this.getClass());
            Field fields[]=this.getClass().getDeclaredFields();
            for (int i=0; i<fields.length; i++) {
                //Field f=this.getClass().getDeclaredField((String) fieldNames.elementAt(i));
                Field f=this.getClass().getDeclaredFields()[i];
                try {
                    Object o=valueOf(f, r, i+1);
                    f.set(this, o);
                }
                catch (Exception j) { 
                    // to prevent null values
                }
            }
        }
    }

    String getMetaInformation() {
		String fieldName, fieldClass, fieldValue, result=new String();
		Field f;
		Field listOfFields[];
    
        try {
            listOfFields=this.getClass().getDeclaredFields();
            for (int i=0; i<listOfFields.length; i++) {
                f=listOfFields[i];
                fieldClass=f.getType().toString();
                fieldValue=f.get(this).toString();
                result+=f.getName() + " is of " + fieldClass + 
                    " and its value is " + fieldValue + "\n";
            }
        }
        catch (Exception e) {
            System.out.println("Error en CPI.getMetaInformation(): " + e);
        }
        return result;
    }
    
    Object getValue(int i) {
		String fieldValue; Object resul=new Object();
		Field f=this.getClass().getDeclaredFields()[i];
		try {
		    return f.get(this);
		}
		catch (Exception e) {
            return new Object();
        }
    }
    
    String marks(String value, String className) {
        if (className.compareTo("class java.lang.String")==0)
            return "'" + value + "'";
        else if (className.compareTo("class java.util.Date")==0)
            return "#" + value + "#";
        else
            return value;
    }
    
    // Devuelve una lista de values preparada para hacer un Insert into
    private String getListOfValues() throws Exception {
		String fieldName, fieldClass, fieldValue, result=new String();
		Field f;
		Field fields[];
    
        fields=this.getClass().getDeclaredFields();
        System.out.println("Hay " + fields.length + " campos:");
        for (int i=0; i<fields.length; i++) {
            f=fields[i];
            fieldClass=f.getType().toString();
            fieldValue=f.get(this).toString();
            result+=marks(fieldValue, fieldClass)+",";
        }
        return result.substring(0, result.length()-1);
    }

    // Devuelve una lista de columns y values preparada para hacer un Insert into
    // o una bsqueda (depende del parmetro)
    Vector getListOfColumnsAndValues() throws Exception {
        Vector result, columns, values;
		String fieldName, fieldClass, fieldValue;
		Field f;
		Field fields[];
    
        columns=new Vector(); values=new Vector();

        fields=this.getClass().getDeclaredFields();
        for (int i=0; i<fields.length; i++) {
            f=fields[i];
            if (isValid(f)) {
                fieldClass=f.getType().toString();
                fieldName=f.getName();
                fieldValue=f.get(this).toString();
                if (fieldValue!=null) {
                    columns.addElement(this.trim(fieldName)+",");
                    values.addElement(marks(fieldValue, fieldClass)+",");
                }
            }
        }
        result=new Vector();
        String aux=(String) columns.elementAt(columns.size()-1);
        columns.removeElementAt(columns.size()-1);
        aux=aux.substring(0, aux.length()-1);
        columns.addElement(aux);
        aux=(String) values.elementAt(values.size()-1);        
        values.removeElementAt(values.size()-1);
        aux=aux.substring(0, aux.length()-1);        
        values.addElement(aux);
        result.addElement(columns); result.addElement(values);
        return result;
    }

    private boolean isValid(Field f) {
        String className= f.getType().toString();
        String validFields[]={
            "class java.lang.Long", "class java.lang.Integer", 
            "class java.lang.Double", "class java.lang.String", 
            "class java.lang.Boolean", "class java.util.Date" };
        for (int i=0; i<validFields.length; i++) {
            if ((className.compareTo(validFields[i])==0) && 
                (f.getName().startsWith("m")))
                return true;
        }
        return false;
    }
    
    String trim(String fieldName) {
        if (fieldName.substring(0, 3).compareTo("mPK")==0)
            fieldName=fieldName.substring(3, fieldName.length());        
        else
            fieldName=fieldName.substring(1, fieldName.length());        
        return fieldName;
    }
    
    // Devuelve una lista con las columns de una tabla, de este estilo:
    //   [Nombre], [Apellido 1], ...
    // Se usa al ejecutar Insert into tabla ([Nombre], [Apellido 1], ...)
    private String getListOfTableColumns() throws Exception {
		String fieldName, result=new String();
		Field f;
		Field fields[];
    
        fields=this.getClass().getDeclaredFields();
        for (int i=0; i<fields.length; i++) {
            f=fields[i];
            if (isValid(f)) {
                fieldName=f.getName();
                //System.out.println(i + ": " + fieldName);
                fieldName=trim(fieldName);
                result+="[" + fieldName + "],";
            }
        }
        return result.substring(0, result.length()-1) ;
    }
    
    // Devuelve un vector que contiene los nombres de todos los atributos 
    // vlidos de esta clase, incluyendo los que son de clase vector.
    public Vector getListOfFieldsWithVector(Class clase) {
        Class padre;
        Vector result=new Vector();
        Field f, fields[];
        int counter=0; 
        fields=clase.getDeclaredFields();
        for (int i=0; i<fields.length; i++) {
            f=fields[i];
            if ((isValid(f)) || 
                (f.getType().toString().compareTo("class java.util.Vector")==0))
                result.addElement(f.getName());
        }
        return result;
    }

    // Devuelve un vector que contiene los nombres de todos los atributos 
    // vlidos de esta clase, excluyendo los que son de clase vector.
    public Vector listOfFields(Class clase) {
        Class padre;
        Vector result=new Vector();
        Field f, fields[];
        int counter=0; 
        fields=clase.getDeclaredFields();
        for (int i=0; i<fields.length; i++) {
            f=fields[i];
            if (isValid(f)) 
                result.addElement(f.getName());
        }
        return result;
    }
    
    private String nameOfAttribute(int i) {
        String fieldName, fieldClass;
        int counter=-1;
        Field fields[]=this.getClass().getDeclaredFields();
        for (int j=0; j<fields.length; j++) {
            Field f=fields[i];
            fieldName=f.getName(); 
            fieldClass=f.getType().toString();
            if (isValid(f) && (++counter==i))
                return trim(fieldName);
        }
        return new String();
    }
    
   
   private String getListOfPrimaryKeysAndValues() throws Exception {
        Field f, fields[];
        String fieldName, fieldValue, fieldClass, result=new String();
        fields=this.getClass().getDeclaredFields();
        for (int i=0; i<fields.length; i++) {
            f=fields[i];
            fieldName=f.getName();
            if ((fieldName.substring(0, 3).compareTo("mPK")==0)) {
                fieldName=trim(fieldName);
                fieldValue=f.get(this).toString();
                fieldClass=f.getType().toString();
                result+="[" + fieldName + "]=" + 
                    marks(fieldValue, fieldClass) + " and ";
            }
        }
        return result.substring(0, result.length()-4);
    }    
        
    // Devuelve una lista de este estilo: Orden=1 and Seccion='A' and ...
    private String getListOfPKsAndValues(String PKValues[]) {
        Field f, fields[];
        String fieldName, fieldValue, fieldClass, result=new String();
        try {
            int cont=0;
            fields=this.getClass().getDeclaredFields();
            for (int i=0; i<PKValues.length; i++) {
                f=fields[i]; 
                fieldName=f.getName(); //System.out.println("Campo " + fieldName);
                if ((fieldName.substring(0, 3).compareTo("mPK")==0)) {
                    fieldName=trim(fieldName);
                    fieldClass=f.getType().toString();
                    result+="[" + fieldName + "]=" + 
                        marks(PKValues[cont++], fieldClass) + " and ";
                }
            }
        }
        catch (Exception e) {
            System.out.println("Error en CPI.listOfPKsAndValues(...): " + e);
        }
        return result.substring(0, result.length()-4);
    }
    
   public void insert() throws Exception {
	    String SQL="Insert into " + this.getClass().getName() +
	        " (" + this.getListOfTableColumns() + 
	        ") values (" + this.getListOfValues() + ")";
	        System.out.println(SQL);
        Broker.createStatement().executeUpdate(SQL);
   }    
   
   private void InsertaVectores() throws Exception {
        Class padre;
        Vector camposV=new Vector();
        Field f, fields[];
        int counter=0; 
        fields=this.getClass().getDeclaredFields();
        // Guardo en camposV todos los campos de clase Vector con formato:
        // mSeccionOperario_Seccion_Nombre
        for (int i=0; i<fields.length; i++) {
            f=fields[i];
            if ((f.getType().toString().compareTo("class java.util.Vector")==0) && 
               (EsVectorValido(f.getName())))
                camposV.addElement(f);
        }
        for (int i=0; i<camposV.size(); i++) {
            f=(Field) camposV.elementAt(i);
            Vector v=(Vector) f.get(this);
            String campo=f.getName();
            String tabla=NombreDeTabla(campo);
            String campoDeBusqueda=NombreDelPrimerCampo(campo);
            String claseBusqueda=this.getClass().getDeclaredField("mPK"+campoDeBusqueda).getType().toString();
            String campoDeMuestra=NombreDelSegundoCampo(campo);
            // Guardo en "valor" el valor del campo "Seccion"
            String valor=this.getClass().getDeclaredField("mPK"+campoDeBusqueda).get(this).toString();
            String SQL="Delete from [" + tabla + "] where [" +
                campoDeBusqueda + "]=" + marks(valor, claseBusqueda);
            Broker.bd.createStatement().executeUpdate(SQL);
            for (int j=0; j<v.size(); j++) {
                Object o=(Object) v.elementAt(j);
                SQL="Insert into [" + tabla + "] ([" +
                    campoDeBusqueda + "], [" + campoDeMuestra + "]) values (" +
                    marks(valor, claseBusqueda) + ", " +
                    marks(o.toString(), o.getClass().toString()) + ")";
                Broker.bd.createStatement().executeUpdate(SQL);
            }
        }
   }
   
   // Devuelve el nombre de la tabla a la que se refiere este 
   // atributo de clase vector, que debe tener el formato 
   // mSeccionOperario_Seccion_Nombre ("SeccionOperario", en este caso)   
   private String NombreDeTabla(String campo) {
        int posSub1=-1; String tabla=new String();
        for (int i=0; (i<campo.length()) && (posSub1==-1); i++)
            if (campo.charAt(i)=='_') posSub1=i;
        if (posSub1!=-1) 
            tabla=campo.substring(1, posSub1);
        return tabla;
   }
   
   // Devuelve el nombre del primer campo (de bsqueda) en un
   // atributo de clase vector que tenga el formato 
   // mSeccionOperario_Seccion_Nombre ("Seccion", en este caso)
   private String NombreDelPrimerCampo(String campo) {
        int posSub1=-1, posSub2=-1;
        for (int i=0; (i<campo.length()) && (posSub1==-1); i++)
            if (campo.charAt(i)=='_') posSub1=i;
        for (int i=posSub1+1; (i<campo.length()) && (posSub2==-1); i++)
            if (campo.charAt(i)=='_') posSub2=i;
        return campo.substring(posSub1+1, posSub2);
   }   
   
   // Devuelve el nombre del segundo campo (de muestra) en un
   // atributo de clase vector que tenga el formato 
   // mSeccionOperario_Seccion_Nombre ("Operario", en este caso)   
   private String NombreDelSegundoCampo(String campo) {
        int posSub1=-1, posSub2=-1;
        for (int i=0; (i<campo.length()) && (posSub1==-1); i++)
            if (campo.charAt(i)=='_') posSub1=i;
        for (int i=posSub1+1; (i<campo.length()) && (posSub2==-1); i++)
            if (campo.charAt(i)=='_') posSub2=i;
        return campo.substring(posSub2+1);
   }   
   
   // Devuelve true si el nombre del campo pasado como parmetro es de 
   // clase vector y adems es insertable (e.d.: mSeccionOperario_Seccion_Nombre)
   private boolean EsVectorValido(String campo) {
        int cont=0;
        for (int i=0; i<campo.length(); i++) 
            if (campo.charAt(i)=='_') cont++;
        return (cont==2);
   }
   
   public void update() throws Exception {
        String fieldClass;
        String fieldValue;
        String SQL="Update " + this.getClass().getName() + " set ";
        Vector fieldNames=listOfFields(this.getClass());
        for (int i=0; i<fieldNames.size(); i++) {
            Field f=this.getClass().getDeclaredField((String) fieldNames.elementAt(i));                
//            try {
                fieldValue=f.get(this).toString();
  /*          }
            catch (Exception e) {
                fieldValue=null;
            }
            if (fieldValue!=null) {*/
                fieldClass=f.getType().toString();
                SQL= SQL + "[" + trim(f.getName()) + "]=";
                SQL=SQL+marks(fieldValue, f.getType().toString()) + ",";
        }
        SQL=SQL.substring(0, SQL.length()-1);
        SQL= SQL + " where " + this.oldPKs;
        System.out.println("Update creada: " + SQL);
        Broker.bd.createStatement().executeUpdate(SQL);
   }
   
   public void delete() throws Exception {
        String SQL="Delete from " + this.getClass().getName() + 
            " where " + getListOfPrimaryKeysAndValues();
        System.out.println("Delete creada: " + SQL);
        Broker.bd.createStatement().executeUpdate(SQL);
   }
   
   public void Vacia() {
        Vector fieldNames=listOfFields(this.getClass());
        for (int i=0; i<fieldNames.size(); i++) {
            try {
                Field f=this.getClass().getDeclaredField((String) fieldNames.elementAt(i));                
                f.set(this, Vacio(f));
            }
            catch (Exception e) {
                System.out.println("Error en CPI.Vacia(): " + e);
            }
        }
    }   
    
	protected String CamposVisibles() {
	    String resul=new String();
	    String SQL="Select [Campos visibles] from Tablas where Nombre='" + 
	        this.getClass().getName() + "'";
        try {
           ResultSet r=Broker.bd.createStatement().executeQuery(SQL);
            if (r.next()) {
                resul=r.getString(1);
            }
        }
        catch (Exception e) {
            CTES.Error("No se han definido Campos visibles para " + this.getClass().getName());
        }
        return resul;
	}
	
	private String AndOR() {
	    /*if (Configuracion.kConsiderarOr)
	        return " OR  ";
	    else*/
	        return " AND ";
	}

	private String Operador() {
	    //return Configuracion.kOperadorDeComparacion;
	    return "=";
	}
    	
    public void show() {
		String fieldValue;
		Field f;
		Field listOfFields[];
    
        listOfFields=this.getClass().getDeclaredFields();
        for (int i=0; i<listOfFields.length; i++) {
            try {
                f=listOfFields[i];
                fieldValue=f.get(this).toString();
                System.out.print(f.getName() + "=<" + fieldValue + ">;\t");
            }
            catch (Exception e) { }
        }
    }	

    public Vector toVector() {
		String fieldValue;
		Field f;
		Field listOfFields[];
		Vector r=new Vector();
    
        listOfFields=this.getClass().getDeclaredFields();
        for (int i=0; i<listOfFields.length; i++) {
            try {
                f=listOfFields[i];
                fieldValue=f.get(this).toString();
                r.addElement(f.getName() + "=<" + fieldValue + ">");
            }
            catch (Exception e) {}
        }
        return r;
    }	

    
    public String getXML() {
        String resul="<"+this.getClass().getName()+">\n";
        Vector columns=this.getListOfFieldsWithVector(this.getClass());

        for (int i=0; i<columns.size(); i++) {
            String c=(String) columns.elementAt(i);
            Object v=this.getValue(i);
            if (v.getClass().getName().equals("class java.util.Vector")) {
                resul=resul+"\t<"+c+"s>\n\t\t";
                if (v==null)
                    v="";
                resul=resul+v.toString()+"\n\t</"+c+"s>\n";
                Vector aux=(Vector) v;
                for (int j=0; j<aux.size(); j++) {
                    Object e=aux.elementAt(j);
                    resul=resul+"<"+c+">\n\t"+e.toString()+"</"+c+">\n";
                }
            } else
                resul=resul+"\t<"+c+">\n\t\t"+v.toString()+"\n\t</"+c+">\n";
        }
        resul=resul+"</"+this.getClass().getName()+">";
        return resul;
    }
	//{{DECLARE_CONTROLS
	//}}
}
			
			
